package org.jeecg.modules.system.app.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.system.app.entity.Protocol;
import org.jeecg.modules.system.app.service.IProtocolService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Arrays;
 /**
 * @Description: 协议说明
 * @Author: jeecg-boot
 * @Date:   2025-07-31
 * @Version: V1.0
 */
@Tag(name="协议说明")
@RestController
@RequestMapping("/protocol/protocol")
@Slf4j
public class ProtocolController extends JeecgController<Protocol, IProtocolService> {
	@Autowired
	private IProtocolService protocolService;
	
	/**
	 * 分页列表查询
	 *
	 * @param protocol
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "协议说明-分页列表查询")
	@Operation(summary="协议说明-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<Protocol>> queryPageList(Protocol protocol,
												 @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
												 @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
												 HttpServletRequest req) {


        QueryWrapper<Protocol> queryWrapper = QueryGenerator.initQueryWrapper(protocol, req.getParameterMap());
		Page<Protocol> page = new Page<Protocol>(pageNo, pageSize);
		IPage<Protocol> pageList = protocolService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param protocol
	 * @return
	 */
	@AutoLog(value = "协议说明-添加")
	@Operation(summary="协议说明-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody Protocol protocol) {

		Protocol protocolNew =	protocolService.findByInsuranceName(protocol.getInsuranceName(),null);
		if (protocolNew!=null){
			return Result.error("添加失败！该保险公司已存在");
		}
		protocolService.save(protocol);

		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param protocol
	 * @return
	 */
	@AutoLog(value = "协议说明-编辑")
	@Operation(summary="协议说明-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody Protocol protocol) {
		Protocol protocolNew =	protocolService.findByInsuranceName(protocol.getInsuranceName(),protocol.getId());
		if (protocolNew!=null){
			return Result.error("修改失败！该保险公司已存在");
		}
		protocolService.updateById(protocol);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "协议说明-通过id删除")
	@Operation(summary="协议说明-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		protocolService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "协议说明-批量删除")
	@Operation(summary="协议说明-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.protocolService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "协议说明-通过id查询")
	@Operation(summary="协议说明-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<Protocol> queryById(@RequestParam(name="id",required=true) String id) {
		Protocol protocol = protocolService.getById(id);
		if(protocol==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(protocol);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param protocol
    */
    @RequiresPermissions("protocol:nm_protocol:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, Protocol protocol) {
        return super.exportXls(request, protocol, Protocol.class, "协议说明");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("protocol:nm_protocol:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, Protocol.class);
    }

}
